discard
cscript "beta" adofiles zoib zoib_beta_lf zoib_p
use bench/citybudget.dta, clear

zoib governing minorityleft noleft houseval popdens, robust


assert `"`e(predict)'"'    == `"zoib_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(cmd)'"'        == `"zoib"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(vcetype)'"'    == `"Robust"'
assert `"`e(opt)'"'        == `"ml"'
assert `"`e(title)'"'      == `"ML fit of beta"'
assert `"`e(user)'"'       == `"zoib_beta_lf"'
assert `"`e(crittype)'"'   == `"log pseudolikelihood"'
assert `"`e(technique)'"'  == `"nr"'


assert         e(rc)         == 0
assert reldif( e(ll)          , 768.0670364237857 ) <  1E-8
assert         e(k)          == 6
assert         e(k_eq)       == 2
assert         e(k_dv)       == 1
assert         e(ic)         == 4
assert         e(N)          == 394
assert         e(rank)       == 6
assert         e(df_m)       == 4
assert reldif( e(chi2)        , 96.04499642609555 ) <  1E-8
assert reldif( e(p)           , 6.83108136468e-20 ) <  1E-8
tempname T_b 
mat `T_b' = J(1,6,0)
mat `T_b'[1,1] = -.1021429525487131
mat `T_b'[1,2] =  .1047122759988964
mat `T_b'[1,3] =  .2970051094693041
mat `T_b'[1,4] = -.1247096767900407
mat `T_b'[1,5] = -2.607600842925023
mat `T_b'[1,6] =  4.168403043649711
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-8
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"proportion:minorityleft proportion:noleft proportion:houseval proportion:popdens proportion:_cons ln_phi:_cons"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(6,6,0)
mat `T_V'[1,1] =   .004367194701309
mat `T_V'[1,2] =  .0037935948171747
mat `T_V'[1,3] = -.0006083651980239
mat `T_V'[1,4] =  .0002974378304516
mat `T_V'[1,5] = -.0030816505882359
mat `T_V'[1,6] =  .0015328888631246
mat `T_V'[2,1] =  .0037935948171747
mat `T_V'[2,2] =  .0049954913881157
mat `T_V'[2,3] = -.0008125353211074
mat `T_V'[2,4] =  .0004063777589331
mat `T_V'[2,5] = -.0030222144626741
mat `T_V'[2,6] =  .0014335046073582
mat `T_V'[3,1] = -.0006083651980239
mat `T_V'[3,2] = -.0008125353211074
mat `T_V'[3,3] =  .0033158684294908
mat `T_V'[3,4] =   .000010646608317
mat `T_V'[3,5] = -.0041845420812022
mat `T_V'[3,6] = -.0004498333601386
mat `T_V'[4,1] =  .0002974378304516
mat `T_V'[4,2] =  .0004063777589331
mat `T_V'[4,3] =   .000010646608317
mat `T_V'[4,4] =   .000534725310507
mat `T_V'[4,5] =  -.000657288772164
mat `T_V'[4,6] =  -.000097233903769
mat `T_V'[5,1] = -.0030816505882359
mat `T_V'[5,2] = -.0030222144626741
mat `T_V'[5,3] = -.0041845420812022
mat `T_V'[5,4] =  -.000657288772164
mat `T_V'[5,5] =  .0097245826437625
mat `T_V'[5,6] = -.0013631011339955
mat `T_V'[6,1] =  .0015328888631246
mat `T_V'[6,2] =  .0014335046073582
mat `T_V'[6,3] = -.0004498333601386
mat `T_V'[6,4] =  -.000097233903769
mat `T_V'[6,5] = -.0013631011339955
mat `T_V'[6,6] =   .007143742688289
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-8
_assert_streq `"`: rowfullnames `C_V''"' `"proportion:minorityleft proportion:noleft proportion:houseval proportion:popdens proportion:_cons ln_phi:_cons"'
_assert_streq `"`: colfullnames `C_V''"' `"proportion:minorityleft proportion:noleft proportion:houseval proportion:popdens proportion:_cons ln_phi:_cons"'
mat drop `C_V' `T_V'


// check mfx
mfx

assert `"`e(Xmfx_type)'"'      == `"dydx"'
assert `"`e(Xmfx_discrete)'"'  == `"discrete"'
assert `"`e(Xmfx_cmd)'"'       == `"mfx"'
assert `"`e(Xmfx_label_p)'"'   == `"Proportion"'
assert `"`e(Xmfx_dummy)'"'     == `" 1 1 0 0"'
assert `"`e(Xmfx_variables)'"' == `"1 1 1 1"'
assert `"`e(Xmfx_method)'"'    == `"linear"'

assert reldif( e(Xmfx_y)      , .0942002836257514 ) <  1E-8

tempname T_Xmfx_se_dydx 
mat `T_Xmfx_se_dydx' = J(1,4,0)
mat `T_Xmfx_se_dydx'[1,1] =   .005625932182418
mat `T_Xmfx_se_dydx'[1,2] =  .0061182674104505
mat `T_Xmfx_se_dydx'[1,3] =  .0050035138031811
mat `T_Xmfx_se_dydx'[1,4] =  .0019628586520391
tempname C_Xmfx_se_dydx
matrix `C_Xmfx_se_dydx' = e(Xmfx_se_dydx)
assert mreldif( `C_Xmfx_se_dydx' , `T_Xmfx_se_dydx' ) < 1E-8
_assert_streq `"`: rowfullnames `C_Xmfx_se_dydx''"' `"r1"'
_assert_streq `"`: colfullnames `C_Xmfx_se_dydx''"' `"minorityleft noleft houseval popdens"'
mat drop `C_Xmfx_se_dydx' `T_Xmfx_se_dydx'

tempname T_Xmfx_dydx 
mat `T_Xmfx_dydx' = J(1,4,0)
mat `T_Xmfx_dydx'[1,1] =  -.008669777438026
mat `T_Xmfx_dydx'[1,2] =  .0090237675210933
mat `T_Xmfx_dydx'[1,3] =  .0253424332312079
mat `T_Xmfx_dydx'[1,4] = -.0106410514720918
tempname C_Xmfx_dydx
matrix `C_Xmfx_dydx' = e(Xmfx_dydx)
assert mreldif( `C_Xmfx_dydx' , `T_Xmfx_dydx' ) < 1E-8
_assert_streq `"`: rowfullnames `C_Xmfx_dydx''"' `"r1"'
_assert_streq `"`: colfullnames `C_Xmfx_dydx''"' `"minorityleft noleft houseval popdens"'
mat drop `C_Xmfx_dydx' `T_Xmfx_dydx'

tempname T_Xmfx_X 
mat `T_Xmfx_X' = J(1,4,0)
mat `T_Xmfx_X'[1,1] =   .434010152284264
mat `T_Xmfx_X'[1,2] =  .3857868020304568
mat `T_Xmfx_X'[1,3] =  1.492487308186323
mat `T_Xmfx_X'[1,4] =  .7628604059206879
tempname C_Xmfx_X
matrix `C_Xmfx_X' = e(Xmfx_X)
assert mreldif( `C_Xmfx_X' , `T_Xmfx_X' ) < 1E-8
_assert_streq `"`: rowfullnames `C_Xmfx_X''"' `"r1"'
_assert_streq `"`: colfullnames `C_Xmfx_X''"' `"minorityleft noleft houseval popdens"'
mat drop `C_Xmfx_X' `T_Xmfx_X'



// check predictions
predict pr, pr
predict prcond, prcond
predict pr1, pr1
predict pr0, pr0
if c(stata_version) < 9 {
	rcof "predict sc1, score eq(#1)" == 9
	rcof "predict sc2, score eq(#2)" == 9
}
else{
	predict sc1, score eq(#1)
	predict sc2, score eq(#2)
}

predict xb1, xb eq(#1)
predict xb2, xb eq(#2)

sum pr
assert reldif( r(sum)    , 40.75633670017123 ) <  1E-8
assert reldif( r(max)    , .1853322982788086 ) <  1E-8
assert reldif( r(min)    , .0423296615481377 ) <  1E-8
assert reldif( r(sd)     , .0186857361800865 ) <  1E-8
assert reldif( r(Var)    , .0003491567365918 ) <  1E-8
assert reldif( r(mean)   , .0952250857480636 ) <  1E-8
assert         r(sum_w) == 428
assert         r(N)     == 428

sum prcond
assert reldif( r(sum)    , 40.75633670017123 ) <  1E-8
assert reldif( r(max)    , .1853322982788086 ) <  1E-8
assert reldif( r(min)    , .0423296615481377 ) <  1E-8
assert reldif( r(sd)     , .0186857361800865 ) <  1E-8
assert reldif( r(Var)    , .0003491567365918 ) <  1E-8
assert reldif( r(mean)   , .0952250857480636 ) <  1E-8
assert         r(sum_w) == 428
assert         r(N)     == 428

sum pr1
assert         r(sum)   == 0
assert         r(max)   == 0
assert         r(min)   == 0
assert         r(sd)    == 0
assert         r(Var)   == 0
assert         r(mean)  == 0
assert         r(sum_w) == 429
assert         r(N)     == 429

sum pr0
assert         r(sum)   == 0
assert         r(max)   == 0
assert         r(min)   == 0
assert         r(sd)    == 0
assert         r(Var)   == 0
assert         r(mean)  == 0
assert         r(sum_w) == 429
assert         r(N)     == 429

if c(stata_version) >= 9 {
	sum sc1
	assert reldif( r(sum)    , -1.21178444151e-07) <  1E-8
	assert reldif( r(max)    , 8.558358430593211 ) <  1E-8
	assert reldif( r(min)    , -7.635302729835369) <  1E-8
	assert reldif( r(sd)     , 2.451683141103479 ) <  1E-8
	assert reldif( r(Var)    , 6.010750224371021 ) <  1E-8
	assert reldif( r(mean)   , -3.07559502920e-10) <  1E-8
	assert         r(sum_w) == 394
	assert         r(N)     == 394

	sum sc2
	assert reldif( r(sum)    , -4.52919766700e-08) <  1E-8
	assert reldif( r(max)    , .5250811910811924 ) <  1E-8
	assert reldif( r(min)    , -8.385012021153175) <  1E-8
	assert reldif( r(sd)     , .8136555191536687 ) <  1E-8
	assert reldif( r(Var)    , .6620353038492263 ) <  1E-8
	assert reldif( r(mean)   , -1.14954255508e-10) <  1E-8
	assert         r(sum_w) == 394
	assert         r(N)     == 394
}
	
sum xb1
assert reldif( r(sum)    , -971.6760483980179) <  1E-8
assert reldif( r(max)    , -1.480629920959473) <  1E-8
assert reldif( r(min)    , -3.119015455245972) <  1E-8
assert reldif( r(sd)     , .2171651625961318 ) <  1E-8
assert reldif( r(Var)    , .0471607078454044 ) <  1E-8
assert reldif( r(mean)   , -2.270271141116864) <  1E-8
assert         r(sum_w) == 428
assert         r(N)     == 428

sum xb2
assert reldif( r(sum)    , 1788.244950771332 ) <  1E-8
assert reldif( r(max)    , 4.168403148651123 ) <  1E-8
assert reldif( r(min)    , 4.168403148651123 ) <  1E-8
assert         r(sd)    == 0
assert         r(Var)   == 0
assert reldif( r(mean)   , 4.168403148651123 ) <  1E-8
assert         r(sum_w) == 429
assert         r(N)     == 429



// check if data type is respected
confirm float variable pr prcond pr1 pr0 
drop pr prcond pr1 pr0
predict double pr, pr
predict double prcond, prcond
predict double pr1, pr1
predict double pr0, pr0
confirm double variable pr prcond pr1 pr0
drop pr prcond pr1 pr0

// check if
use bench/citybudget.dta, clear
keep if houseval > 1.5
zoib governing minorityleft noleft houseval popdens , 
savedresults save mustbetrue e()
use bench/citybudget.dta, clear
zoib governing minorityleft noleft houseval popdens if houseval > 1.5, 
savedresults compare mustbetrue e()
savedresults drop mustbetrue



// no zeroinflate oneinflate when no zeros or ones in depvar
rcof "zoib governing minorityleft noleft houseval popdens , zeroinflate( minorityleft noleft houseval popdens)" == 198
rcof "zoib governing minorityleft noleft houseval popdens , oneinflate( minorityleft noleft houseval popdens)" == 198

// phivar
zoib governing minorityleft noleft houseval popdens, phivar(houseval popdens)

assert `"`e(predict)'"'    == `"zoib_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(cmd)'"'        == `"zoib"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(opt)'"'        == `"ml"'
assert `"`e(title)'"'      == `"ML fit of beta"'
assert `"`e(user)'"'       == `"zoib_beta_lf"'
assert `"`e(crittype)'"'   == `"log likelihood"'
assert `"`e(technique)'"'  == `"nr"'

assert         e(rc)         == 0
assert reldif( e(ll)          , 774.7186305646168 ) <  1E-8
assert         e(rank)       == 8
assert         e(k)          == 8
assert         e(k_eq)       == 2
assert         e(k_dv)       == 1
assert         e(N)          == 394
assert         e(df_m)       == 4
assert reldif( e(chi2)        , 111.9783616775288 ) <  1E-8
assert reldif( e(p)           , 2.75422952728e-23 ) <  1E-8

tempname T_b 
mat `T_b' = J(1,8,0)
mat `T_b'[1,1] = -.0604393012335098
mat `T_b'[1,2] =  .1492326275963413
mat `T_b'[1,3] =  .3969023459701618
mat `T_b'[1,4] = -.1226784430949176
mat `T_b'[1,5] = -2.796562063728474
mat `T_b'[1,6] = -.7047494845298594
mat `T_b'[1,7] =   .004096553394806
mat `T_b'[1,8] =  5.252839174505074
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-8
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"proportion:minorityleft proportion:noleft proportion:houseval proportion:popdens proportion:_cons ln_phi:houseval ln_phi:popdens ln_phi:_cons"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(8,8,0)
mat `T_V'[1,1] =  .0035493723596795
mat `T_V'[1,2] =  .0025861438207396
mat `T_V'[1,3] =  -.000155703108178
mat `T_V'[1,4] =  .0000452299201199
mat `T_V'[1,5] = -.0023144978686554
mat `T_V'[1,6] = -.0020935946120178
mat `T_V'[1,7] =  .0008861694223547
mat `T_V'[1,8] =   .002422928287454
mat `T_V'[2,1] =  .0025861438207396
mat `T_V'[2,2] =  .0037456815081009
mat `T_V'[2,3] =  -.000562290762035
mat `T_V'[2,4] =  .0001946266062922
mat `T_V'[2,5] = -.0019182120223729
mat `T_V'[2,6] = -.0023723620839896
mat `T_V'[2,7] =  .0004550043992642
mat `T_V'[2,8] =  .0032443151123676
mat `T_V'[3,1] =  -.000155703108178
mat `T_V'[3,2] =  -.000562290762035
mat `T_V'[3,3] =  .0039015399308059
mat `T_V'[3,4] =  .0000996142818937
mat `T_V'[3,5] = -.0054181863838554
mat `T_V'[3,6] = -.0053395927182409
mat `T_V'[3,7] = -.0000916211489168
mat `T_V'[3,8] =  .0079328142700001
mat `T_V'[4,1] =  .0000452299201199
mat `T_V'[4,2] =  .0001946266062922
mat `T_V'[4,3] =  .0000996142818937
mat `T_V'[4,4] =  .0006277405092668
mat `T_V'[4,5] =  -.000673813074746
mat `T_V'[4,6] = -.0001548631788585
mat `T_V'[4,7] = -.0003119102257211
mat `T_V'[4,8] =  .0004194173463116
mat `T_V'[5,1] = -.0023144978686554
mat `T_V'[5,2] = -.0019182120223729
mat `T_V'[5,3] = -.0054181863838554
mat `T_V'[5,4] =  -.000673813074746
mat `T_V'[5,5] =  .0104686857982546
mat `T_V'[5,6] =   .009699190973349
mat `T_V'[5,7] = -.0002127587503408
mat `T_V'[5,8] = -.0144886117132905
mat `T_V'[6,1] = -.0020935946120178
mat `T_V'[6,2] = -.0023723620839896
mat `T_V'[6,3] = -.0053395927182409
mat `T_V'[6,4] = -.0001548631788585
mat `T_V'[6,5] =   .009699190973349
mat `T_V'[6,6] =  .0411282485048587
mat `T_V'[6,7] =  .0017217074044117
mat `T_V'[6,8] = -.0627123800175348
mat `T_V'[7,1] =  .0008861694223547
mat `T_V'[7,2] =  .0004550043992642
mat `T_V'[7,3] = -.0000916211489168
mat `T_V'[7,4] = -.0003119102257211
mat `T_V'[7,5] = -.0002127587503408
mat `T_V'[7,6] =  .0017217074044117
mat `T_V'[7,7] =  .0080958090284253
mat `T_V'[7,8] = -.0087662871295951
mat `T_V'[8,1] =   .002422928287454
mat `T_V'[8,2] =  .0032443151123676
mat `T_V'[8,3] =  .0079328142700001
mat `T_V'[8,4] =  .0004194173463116
mat `T_V'[8,5] = -.0144886117132905
mat `T_V'[8,6] = -.0627123800175348
mat `T_V'[8,7] = -.0087662871295951
mat `T_V'[8,8] =   .105434409642785
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-8
_assert_streq `"`: rowfullnames `C_V''"' `"proportion:minorityleft proportion:noleft proportion:houseval proportion:popdens proportion:_cons ln_phi:houseval ln_phi:popdens ln_phi:_cons"'
_assert_streq `"`: colfullnames `C_V''"' `"proportion:minorityleft proportion:noleft proportion:houseval proportion:popdens proportion:_cons ln_phi:houseval ln_phi:popdens ln_phi:_cons"'
mat drop `C_V' `T_V'


exit
